<?php
/**
* @author Guillermo Vargas, http://joomla.vargas.co.cr
* @email guille@vargas.co.cr
* @version $Id: com_fireboard.php 83 2008-02-03 23:21:17Z root $
* @package Xmap
* @license GNU/GPL
* @description Xmap plugin for Fireboard. 
*/

/** Handles FireBoard forum structure */
class xmap_com_fireboard {

	function getTree ( &$xmap, &$parent, &$params ) {
		$catid=0;
		if ( strpos($parent->link, 'func=showcat') ) {
			$link_query = parse_url( $parent->link );
			parse_str( html_entity_decode($link_query['query']), $link_vars);
			$catid = mosGetParam($link_vars,'catid',0);
		}

		$include_topics = mosGetParam($params,'include_topics',1);
		$include_topics = ( $include_topics == 1
                                  || ( $include_topics == 2 && $xmap->view == 'xml') 
                                  || ( $include_topics == 3 && $xmap->view == 'html'));
		$params['include_topics'] = $include_topics;

		$priority = mosGetParam($params,'cat_priority',$parent->priority);
		$changefreq = mosGetParam($params,'cat_changefreq',$parent->changefreq);
		if ($priority  == '-1')
			$priority = $parent->priority;
		if ($changefreq  == '-1')
			$changefreq = $parent->changefreq;

		$params['cat_priority'] = $priority;
		$params['cat_changefreq'] = $changefreq;

		$priority = mosGetParam($params,'topic_priority',$parent->priority);
		$changefreq = mosGetParam($params,'topic_changefreq',$parent->changefreq);
		if ($priority  == '-1')
			$priority = $parent->priority;

		if ($changefreq  == '-1')
			$changefreq = $parent->changefreq;

		$params['topic_priority'] = $priority;
		$params['topic_changefreq'] = $changefreq;

		if ( $include_topics ) {
			$ordering = mosGetParam($params,'topics_order','ordering');
			if ( !in_array($ordering,array('ordering','time','subjet','hits')) )
				$ordering = 'ordering';
			$params['topics_order'] = $ordering = $ordering;

			$params['limit'] = '';
			$params['days'] = '';
			$limit = mosGetParam($params,'max_topics','');
			if ( intval($limit) )
				$params['limit'] = ' LIMIT '.$limit;

			$days = mosGetParam($params,'max_age','');
			if ( intval($days) )
				$params['days'] = ' AND time >='.($xmap->now - ($days*86400)) ." ";
		}

		xmap_com_fireboard::getCategoryTree($xmap, $parent, $params, $catid);
	}

	/* Return category/forum tree */
	function getCategoryTree( &$xmap, &$parent, &$params, $parentCat ) 
	{
		global $database;
		$list = array();
		$query = "SELECT id as cat_id, name as cat_title, ordering FROM #__fb_categories WHERE parent=$parentCat AND published=1 and pub_access <=".$xmap->gid." ORDER BY name";
		$database->setQuery($query);
		$cats = $database->loadObjectList();

		/*get list of categories*/
		$xmap->changeLevel(1);
		$node = new stdclass;
		$node->id   = $parent->id;
		$node->browserNav = $parent->browserNav;
		foreach ( $cats as $cat ) {
			$node->uid   = $parent->uid.'c'.$cat->cat_id;
			$node->name = $cat->cat_title;
			$node->priority = $params['cat_priority'];
			$node->changefreq = $params['cat_changefreq'];
			$node->link = $parent->link.'&amp;func=showcat&amp;catid='.$cat->cat_id;
			if ( $xmap->printNode($node) !== FALSE ) {
				xmap_com_fireboard::getCategoryTree($xmap,$parent,$params,$cat->cat_id);
			}
		}

		if ( $params['include_topics'] ) {
			$query = "SELECT id as forum_id, catid as cat_id, subject as forum_name, time as modified ".
                         	"FROM #__fb_messages ".
                                "WHERE catid=$parentCat ".
                                "AND parent=0 " .
                                $params['days'] .
                                "ORDER BY `". $params['topics_order'] . "`" .
				$params['limit'];

			$database->setQuery($query);
			$forums = $database->loadObjectList();

			//get list of forums
			foreach($forums as $forum) {
				$node->uid = $parent->uid.'t'.$forum->forum_id;
				$node->name = $forum->forum_name;
				$node->priority = $params['topic_priority'];
				$node->changefreq = $params['topic_changefreq'];
				$node->modified = intval($forum->modified);
				$node->link = $parent->link.'&amp;func=view&amp;id='.$forum->forum_id.'&amp;catid='.$forum->cat_id;
				$xmap->printNode($node);
			}
		}
		$xmap->changeLevel(-1);
	}
}
